@warnings
@version 2.7
@script master

/*
======================================================================
Lock selection is a simple script that can lock down selection or 
lock the user to a spasific item type.

www.Steelronin.com
Scott@steelronin.com  
======================================================================
*/


/*
updates comments
*/ 


@name "SR_Lock_Selection"
scriptName = "SR Lock Selection v0.1.0";
copyright = "Copyright (c) 2005 Kvaalen,Scott lange";

//Global Paramters

//Create a scene object agent
scene = Scene();

//The array list of selected items
sellist;

//A boolean value that indicates if selection locking is on or off
lockon;

//The type of the selected items
seltype;

//A boolean value that indicates if selection locking is on or off
locktype;

//When the LScript first gets run...
create
{

//... set the name to Lock Selection...
	setdesc("Lock Selection");

//... and save all the selected items to the sellist array
	sellist = scene.getSelect();
	if(sellist)
		seltype = sellist[1].genus;
}

//Bring up the interface
options
{

//Create an interface/requester panel
	reqbegin("8-)");
	reqsize(115,53);

//Create the Locked Selection check box
		c1 = ctlcheckbox("Lock Selection",0);

//Create the Locked Type check box
		c2 = ctlcheckbox("Lock Item Type",0);

//Go to the "locktoggle" function when clicked on
		ctlrefresh(c1,"locktoggle");

//Go to the "locktitemtype" function when clicked on
		ctlrefresh(c2,"locktitemtype");

//Keep the panel always open
	reqopen();

}

//When clicked on the "Lock Selction" button...
locktitemtype: value
{
//... Save the selected item type
	if(value){
		sellist = scene.getSelect();
		if(sellist)
			seltype = sellist[1].genus;
	}
//Give the lockon boolean variable the on or off value
	locktype = value;
}

//When clicked on the "Lock Selction" button...
locktoggle: value
{
//... save all the selected items to the sellist array
	if(value)
		sellist = scene.getSelect();
//Give the lockon boolean variable the on or off value
	lockon = value;
}

//When ever some event happens (like selecting...)
process: event, command
{
	if(command.size()>10 && (lockon || locktype)){
		if(strleft(command,10)=="SelectItem"||strleft(command,10)=="AddToSelec"){
			if(sellist && lockon){
				SelectItem(sellist[1].id);
				if(sellist.size()>1)
					for(i=2;i<=sellist.size();i++)
						AddToSelection(sellist[i].id);
			}
			if(seltype && locktype){
				newsellist = scene.getSelect();
				if(newsellist){
					newtype = newsellist[1].genus;
					if(seltype != newtype){
						switch(seltype){
							case 1: EditObjects(); break;
							case 2: EditLights(); break;
							case 3: EditCameras(); break;
							case 4: EditBones(); break;
						}
					}
				}
			}
		}
	}
	if(command.size()>8 && locktype){
		if(strleft(command,4)=="Edit"){
			newsellist = scene.getSelect();
			if(newsellist)
				seltype = newsellist[1].genus;
		}
	}
}